//TEST Transmit Unit

//Includes
#include <avr/io.h>
//#include <avr/wdt.h>
#include <avr/interrupt.h>
//#include <util/delay.h>
//#include <avr/pgmspace.h>
//#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
//#include <string.h>

#include "txrx_usart0_head.c"

//definitions
//#define begin {
//#define end }
#define data_length 5
#define tx_id 3
#define threshold 10
//declarations

char data[data_length]; 
unsigned char packet_count;
volatile unsigned int t1;

//**********************************************************
//timer 0 compare ISR
//**********************************************************

ISR (TIMER0_COMPA_vect) {
	if(t1 < threshold) {
		t1++;
		PORTD ^= (1<<6);
	}
}

//**********************************************************
void generate_data(char count)
{                   
	data[0] = count;
	data[1] = 26;
	data[2] = 122;
	data[3] = 75;
	data[4] = 52;
}                                                         


//**********************************************************
//initialization
void init()
{
        //Used for LED array, output
	//DDRC  = 0xff;
	//PORTC = 0xff; //starting off

	//PORTD used for TX.
	//d7 led, d1 TX, d0,d2..6 unused
	DDRD = 0xff;
	PORTD = 0xff;
	//PORTD &= ~(1 << 7); //turn d7 led on as power-on led
                          
  	//set up timer 0  
  	TIMSK0 |= (1<<OCIE0A);		//turn on timer 0 cmp match ISR 
  	OCR0A = 249;  	//set the compare re to 250 time ticks
  	//prescalar to 64 and turn on clear-on-match
  	TCCR0B=(1<<CS02)|(1<<CS00); 
	TCCR0A=(1<<COM0A1); 	
	
	
  	
  	txrx_init(1,0,249,1);//TX only - 4000 baud - led on
  	
	//initialize variables
	t1=0;
    packet_count=0;
	generate_data(packet_count);
 	sei();
}                                                         




//**********************************************************
int main(void)
{
	int thousand = 1000;
	int count = 0;
	init();

	while(1)
	{
	   if (t1 == threshold)
		{
			PORTD ^= (1<<7);		
			t1 = 0;
			generate_data(packet_count);
        	tx_me(data, data_length, tx_id);
			packet_count++;
		}
	} //while
} //main
